﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;
using UnityEngine.SceneManagement;

public class EnemyFollow : MonoBehaviour
{
    public float lookRadius = 10f;
    Transform target;

    public NavMeshAgent enemy;
    public Transform Player;

    public GameObject explosion;

    private WaitForSeconds explosionDuration = new WaitForSeconds(0.05f);
    private AudioSource explosionAudio;

    // Start is called before the first frame update
    void Start()
    {
        target = GameObject.FindGameObjectWithTag("Player").transform;
        enemy = GetComponent<NavMeshAgent>();
        explosionAudio = GetComponent<AudioSource>();

    }

    // Update is called once per frame
    void Update()
    {
        //enemy.SetDestination(Player.position);
        float distance = Vector3.Distance(target.position, transform.position);

        if (distance <= lookRadius)
        {
            enemy.SetDestination(target.position);
            //Explode();
            //StartCoroutine(explosionSoundEffects());

            // edit this area and if statement 
           // Player = GameObject.FindGameObjectWithTag("Player").transform;
           // Enemy = GameObject.FindGameObjectWithTag("Enemy").transform;

         //   if (this.Player.position == this.Enemy.position)
         //   {
          //      Explode();
          //      StartCoroutine(explosionSoundEffects());
          //  }   
        }
    }

    void OnDrawGizmosSelected()
    {
        Gizmos.color = Color.yellow;
        Gizmos.DrawWireSphere(transform.position, lookRadius);
    }


    void OnCollisionEnter(Collision collision)
    {
        if (collision.gameObject.tag == "Player")
        {
           StartCoroutine(explosionSoundEffects());
            Explode();

            //FindObjectOfType<GameManager>().GameOver();
            //SceneManager.LoadScene(SceneManager.GetActiveScene().buildIndex + 0);

            //FindObjectOfType<Player>().PlayerTakeDamage(20);


            //SceneManager.LoadScene(0);
        } 
    } 

  void Explode()
    {
        Instantiate(explosion, transform.position, Quaternion.identity);
    }

  private  IEnumerator explosionSoundEffects()
    {
        explosionAudio.Play();

        yield return explosionDuration;
    }
}