﻿using UnityEngine;
using UnityEngine.UI;

public class OtherSpawn : MonoBehaviour
{
    public GameObject Enemy;
    private float spawnRange = 20f;
    public int enemyCount;
    public int waveNumber = 1;

    public Text enemiesLeft;

    private int score;
    public Text scoreText;

    public GameManager gameManager;

    // Start is called before the first frame update
    void Start()
    {
        SpawnEnemyWave(waveNumber);
        UpdateScore(0);
    }

    // Update is called once per frame
    void Update()
    {
        enemyCount = FindObjectsOfType<EnemyFollow>().Length;

        if (enemyCount == 0)
        {
            waveNumber++;
            SpawnEnemyWave(waveNumber);

            if (waveNumber == 5f)
            {
                gameManager.GameWinner();
            }
        }

        if (enemiesLeft != null)
        {
            enemiesLeft.text = "Enemies left: " + enemyCount;
        }
    }
    
    void SpawnEnemyWave(int enemiesToSpawn)
    {
        for (int i = 0; i < enemiesToSpawn; i++)
        {
            Instantiate(Enemy, GenerateSpawnPosition(), Enemy.transform.rotation);
        }
    }

    private Vector3 GenerateSpawnPosition()
    {
        float spawnPositionX = Random.Range(-spawnRange, spawnRange);
        float spawnPositionY = 0f;
        float spawnPositionZ = Random.Range(-spawnRange, spawnRange);

        Vector3 randomPosition = new Vector3(spawnPositionX, spawnPositionY, spawnPositionZ);

        return randomPosition;
    }

    public void UpdateScore(int scoreToAdd)
    {
        score += scoreToAdd;
        scoreText.text = "Score: " + score;
    }
}